#!/usr/bin/python
import sys, time, glsurface, math
from OpenGL.GL import *
from vec3 import *
from seeker import Seeker

start_time = time.time()
prev_time = start_time
dt = 0.0

def get_time(): return prev_time - start_time

def trigger_time():
    global prev_time, dt
    t = time.time()
    dt = t - prev_time
    prev_time = t

glsurface.init((640, 480))

destination_position = Vec3(7, 0, 0)
destination_radius = 0.5

agent = Seeker()
agent.position = Vec3(-7, 0, 0)
agent.forward = Vec3(-1, 1, 0).normalized()
agent.set_unit_side_from_forward_and_up()
agent.speed = 2.0
agent.max_speed = 4.0
agent.max_force = 3.0
agent.mass = 0.4
agent.radius = 0.7

while True:
    trigger_time()
    glsurface.begin_frame()
    glsurface.setup_ortho(-12, 12, -9, 9)

    glColor4f(0, 0, 0, 0.1)
    glsurface.draw_grid()

    agent.update(dt, destination_position, destination_radius)

    glColor4f(0, 0, 0, 0.4)
    glsurface.draw_circle(destination_position,
                          destination_radius)

    glColor4f(1, 0, 0, 0.5)
    glsurface.draw_circle(agent.position, agent.radius)
    glColor4f(0, 0, 0, 1)
    glsurface.draw_vector(agent.position, agent.velocity())
    
    glsurface.finish_frame()
